Public Class FlowNode
    Public Enum NodeStatusEnum
        statNotInList
        statNowInList
        statWasInList
    End Enum

    Public Status As NodeStatusEnum
    Public AugmentingLink As FlowLink

    Public Name As String
    Public Pt As New Point
    Public Links As New Collection

    Public IsSource As Boolean
    Public IsSink As Boolean

    Public Sub New(ByVal new_x As Integer, ByVal new_y As Integer, ByVal new_name As String)
        Pt.X = new_x
        Pt.Y = new_y
        Name = new_name
    End Sub

    ' Draw the node's links.
    Public Sub DrawLinks(ByVal gr As Graphics, ByVal fnt As Font)
        For Each flow_link As FlowLink In Links
            ' Only draw it we're the first node.
            If Me Is flow_link.Node1 Then
                flow_link.DrawLink(gr, fnt)
            End If
        Next flow_link
    End Sub

    ' Draw the node.
    Public Sub DrawNode(ByVal gr As Graphics)
        Dim NODE_R As Single = 3
        Dim rect As New Rectangle( _
            Pt.X - NODE_R, _
            Pt.Y - NODE_R, _
            2 * NODE_R, _
            2 * NODE_R)
        If IsSource Then
            gr.FillEllipse(Brushes.Red, rect)
        ElseIf IsSink Then
            gr.FillEllipse(Brushes.Yellow, rect)
        Else
            gr.FillEllipse(Brushes.Cyan, rect)
        End If
        gr.DrawEllipse(Pens.Black, rect)
    End Sub
End Class
