Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuDataMakeNetwork As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuDataMakeNetwork = New System.Windows.Forms.MenuItem
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuDataMakeNetwork})
        Me.MenuItem1.Text = "&Data"
        '
        'mnuDataMakeNetwork
        '
        Me.mnuDataMakeNetwork.Index = 0
        Me.mnuDataMakeNetwork.Shortcut = System.Windows.Forms.Shortcut.F5
        Me.mnuDataMakeNetwork.Text = "&Make Network..."
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "ShortestPath"

    End Sub

#End Region

    Private m_PathNodes As New Collection
    Private m_NodeArray(,) As PathNode
    Private m_Dx As Single
    Private m_Dy As Single
    Private m_RootNode As PathNode

    ' Make a test network.
    Private Sub mnuDataMakeNetwork_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDataMakeNetwork.Click
        ' Get network parameters.
        Dim dlg As New dlgMakeNetwork
        If dlg.ShowDialog() = DialogResult.OK Then
            m_PathNodes = New Collection

            ' Get information.
            Dim num_rows As Integer = Integer.Parse(dlg.txtHeight.Text)
            Dim num_cols As Integer = Integer.Parse(dlg.txtWidth.Text)
            Dim num_express_links As Integer = Integer.Parse(dlg.txtExpressLinks.Text)
            m_Dx = ClientSize.Width / (num_cols + 2)
            m_Dy = ClientSize.Height / (num_rows + 2)

            ' Make the nodes.
            ReDim m_NodeArray(num_rows - 1, num_cols - 1)
            For r As Integer = 0 To num_rows - 1
                For c As Integer = 0 To num_cols - 1
                    m_NodeArray(r, c) = New PathNode(m_Dx * (c + 1), m_Dy * (r + 1))
                    m_PathNodes.Add(m_NodeArray(r, c))
                Next c
            Next r

            ' Make vertical connections.
            For r As Integer = 0 To num_rows - 2
                For c As Integer = 0 To num_cols - 1
                    PathLink.LinkNodes(m_NodeArray(r, c), m_NodeArray(r + 1, c))
                Next c
            Next r

            ' Make horizontal connections.
            For c As Integer = 0 To num_cols - 2
                For r As Integer = 0 To num_rows - 1
                    PathLink.LinkNodes(m_NodeArray(r, c), m_NodeArray(r, c + 1))
                Next r
            Next c

            ' Make express links.
            Dim n1 As PathNode
            Dim n2 As PathNode
            Dim new_link As PathLink
            For i As Integer = 1 To num_express_links
                n1 = m_NodeArray(Int(Rnd() * num_rows), Int(Rnd() * num_cols))
                n2 = m_NodeArray(Int(Rnd() * num_rows), Int(Rnd() * num_cols))
                new_link = PathLink.LinkNodes(n1, n2)
                new_link.Cost *= 0.75
            Next i

            ' Redraw.
            Invalidate()
        End If
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.Clear(Me.BackColor)

        ' Draw links.
        For Each path_node As PathNode In m_PathNodes
            path_node.DrawLinks(e.Graphics)
        Next path_node

        ' Draw nodes.
        For Each path_node As PathNode In m_PathNodes
            path_node.DrawNode(e.Graphics)
        Next path_node
    End Sub

    ' Build a shortest path tree from this node.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        ' Find the node clicked.
        If Not m_RootNode Is Nothing Then m_RootNode.IsRoot = False
        m_RootNode = NearestNode(e.X, e.Y)
        m_RootNode.IsRoot = True

        ' Find the shortest path tree.
        ' Reset old data.
        ResetTree()
        m_RootNode.BestCost = 0

        ' Make a candidate list.
        Dim candidates As New Collection
        candidates.Add(m_RootNode)
        m_RootNode.Status = PathNode.NodeStatusEnum.statNowInList

        Dim i As Integer
        Dim best_i As Integer
        Dim best_cost As Single
        Do While candidates.Count > 0
            ' Find the candidate closest to the root.
            best_cost = Single.MaxValue
            For i = 1 To candidates.Count
                With candidates(i)
                    If .BestCost < best_cost Then
                        best_i = i
                        best_cost = .BestCost
                    End If
                End With
            Next i

            ' Add this node to the tree.
            Dim best_node As PathNode = candidates(best_i)
            candidates.Remove(best_i)
            best_node.Status = PathNode.NodeStatusEnum.statWasInList

            ' Examine the node's neighbors.
            Dim neighbor As PathNode
            For Each path_link As PathLink In best_node.Links
                ' Get the neighbor node.
                If path_link.Node1 Is best_node Then
                    neighbor = path_link.Node2
                Else
                    neighbor = path_link.Node1
                End If

                ' See if the node is in the list.
                If neighbor.Status = PathNode.NodeStatusEnum.statNotInList Then
                    ' Has not been in the list. Add it.
                    candidates.Add(neighbor)
                    neighbor.Status = PathNode.NodeStatusEnum.statNowInList
                    neighbor.BestCost = best_cost + path_link.Cost
                    neighbor.FromLink = path_link
                ElseIf neighbor.Status = PathNode.NodeStatusEnum.statNowInList Then
                    ' It's in the list now. 
                    ' Update it's cost if necessary.
                    Dim new_dist As Single = best_cost + path_link.Cost
                    If new_dist < neighbor.BestCost Then
                        neighbor.BestCost = new_dist
                        neighbor.FromLink = path_link
                    End If
                End If
            Next path_link
        Loop

        ' Mark the tree's links for drawing.
        For Each path_node As PathNode In m_PathNodes
            If Not (path_node.FromLink Is Nothing) Then
                path_node.FromLink.InPathTree = True
            End If
        Next path_node

        ' Redraw
        Invalidate()
    End Sub

    ' Return the node nearest this point.
    Private Function NearestNode(ByVal X As Integer, ByVal Y As Integer) As PathNode
        Dim r As Integer = CInt(Y / m_Dy - 1)
        Dim c As Integer = CInt(X / m_Dx - 1)

        If r < 0 Then r = 0
        If r > m_NodeArray.GetUpperBound(0) _
            Then r = m_NodeArray.GetUpperBound(0)
        If c < 0 Then c = 0
        If c > m_NodeArray.GetUpperBound(1) _
            Then c = m_NodeArray.GetUpperBound(1)

        Return m_NodeArray(r, c)
    End Function

    ' Reset all the node's and link's tree flags.
    Private Sub ResetTree()
        For Each path_node As PathNode In m_PathNodes
            path_node.Status = PathNode.NodeStatusEnum.statNotInList
            path_node.FromLink = Nothing
            path_node.BestCost = Single.MaxValue

            For Each path_link As PathLink In path_node.Links
                path_link.InPathTree = False
            Next path_link
        Next path_node
    End Sub
End Class
