Public Class EmployeeDictionary
    Inherits System.Collections.DictionaryBase

    ' Add a Dictionary entry.
    Public Sub Add(ByVal new_key As String, ByVal new_employee As Employee)
        Dictionary.Add(new_key, new_employee)
    End Sub

    ' Return an object with the given key.
    Default Public Property Item(ByVal key As String) As Employee
        Get
            Return CType(Dictionary(key), Employee)
        End Get
        Set(ByVal Value As Employee)
            Dictionary(key) = Value
        End Set
    End Property

    ' Return a collection containing the Dictionary's keys.
    Public ReadOnly Property Keys() As ICollection
        Get
            Return Dictionary.Keys
        End Get
    End Property

    ' Return a collection containing the Dictionary's values.
    Public ReadOnly Property Values() As ICollection
        Get
            Return Dictionary.Values
        End Get
    End Property

    ' Return True if the Dictionary contains this Employee.
    Public Function Contains(ByVal key As String) As Boolean
        Return Dictionary.Contains(key)
    End Function

    ' Remove this entry.
    Public Sub Remove(ByVal key As String)
        Dictionary.Remove(key)
    End Sub
End Class
